//
// main.cpp : program pentru teste de circulatie
//				parte a proiectului auto.dsp
//
#include <windows.h>

#include "header.h"
//-----------------------------------------------------------------------------
// Defines, constants, and global variables
//-----------------------------------------------------------------------------
#define CIMAGW	358 //290	//controlul cu imaginea
#define CIMAGH	290 //235 //!nu modif

#define PRIMA_INIT	-10
#define MAX_REGS	100

struct intrebare
{
public:
	HBITMAP img;
	char text[200];
	char raspuns[4][50];
	char corect[4];
	char select[4];
}sIntreb[MAX_REGS];
int ordine[MAX_REGS];//ordinea in care apar primele iNumarMax intrebari

char FileName[30] = "intreb.txt";
int iCurent = 1,
	iNumarMax,iNumarRaspunsuri,
	abortP;

HINSTANCE hInst;
HBITMAP bmImagine;
int		bWidth,bHeight;

//-----------------------------------------------------------------------------
void UpdateStruct(HWND hDlg, int directie,int care)
{
	if(!directie)
	{
		CheckRadioButton(hDlg,IDC_RADIO1,IDC_RADIO4,care);
		memset(sIntreb[ordine[iCurent]].select,0,4);
		sIntreb[ordine[iCurent]].select[care-IDC_RADIO1] = 1;
	}
	else
	{
		CheckRadioButton(hDlg,IDC_RADIO1,IDC_RADIO4,IDC_RADIO4+1);
		for(int i=0;i<iNumarRaspunsuri;i++)
			if(sIntreb[ordine[iCurent]].select[i])
				CheckRadioButton(hDlg,IDC_RADIO1,IDC_RADIO4,IDC_RADIO1+i);
	}
}
void UpdateInfoDlgText( HWND hDlg , int iNouC) 
{
	TCHAR            strBuffer[128];
	if(iNouC == PRIMA_INIT)
	{
		//prima initializare....
		SetDlgItemText( hDlg,IDC_TEXTUL,sIntreb[ordine[0]].text);
		SetDlgItemText( hDlg,IDC_RADIO1,sIntreb[ordine[0]].raspuns[0]);
		SetDlgItemText( hDlg,IDC_RADIO2,sIntreb[ordine[0]].raspuns[1]);
		SetDlgItemText( hDlg,IDC_RADIO3,sIntreb[ordine[0]].raspuns[2]);
		SetDlgItemText( hDlg,IDC_RADIO4,sIntreb[ordine[0]].raspuns[3]);
		iCurent = iNouC = 0;
		bmImagine = sIntreb[ordine[0]].img;
		if(iNumarRaspunsuri<4)
			EnableWindow( GetDlgItem(hDlg,IDC_RADIO4), FALSE );
		if(iNumarRaspunsuri<3)
			EnableWindow( GetDlgItem(hDlg,IDC_RADIO3), FALSE );
		UpdateStruct(hDlg,1,0);
	}
	if(iNouC != iCurent)
	{
		//s-a produs o modificare, trebuie sa scriu!
		//si incarc din structura de mult pregatita
		iCurent = iNouC;
		SetDlgItemText( hDlg,IDC_TEXTUL,sIntreb[ordine[iCurent]].text);
		SetDlgItemText( hDlg,IDC_RADIO1,sIntreb[ordine[iCurent]].raspuns[0]);
		SetDlgItemText( hDlg,IDC_RADIO2,sIntreb[ordine[iCurent]].raspuns[1]);
		SetDlgItemText( hDlg,IDC_RADIO3,sIntreb[ordine[iCurent]].raspuns[2]);
		SetDlgItemText( hDlg,IDC_RADIO4,sIntreb[ordine[iCurent]].raspuns[3]);
		bmImagine = sIntreb[ordine[iCurent]].img;
		UpdateStruct(hDlg,1,0);
		InvalidateRect(hDlg,NULL,FALSE);
	}
	iCurent = iNouC;   
	wsprintf( strBuffer,"Intrebarea: %d / %d",iCurent+1,iNumarMax);	
	SetDlgItemText( hDlg,IDC_GROUP1,strBuffer);

	HWND hNext = GetDlgItem( hDlg, IDC_BUTTON2 );
    HWND hPrev = GetDlgItem( hDlg, IDC_BUTTON1 );

	if(iCurent <= 0)
	{
		EnableWindow( hPrev, FALSE );
	}
    else
    {
        if( IsWindowEnabled( hPrev ) == FALSE )
            EnableWindow( hPrev, TRUE );
    }
    if(iCurent == iNumarMax-1)
	{
		EnableWindow( hNext, FALSE );
	}
	else
	{
	   if( IsWindowEnabled( hNext ) == FALSE )
            EnableWindow( hNext, TRUE );
    }
}
BOOL CALLBACK InfoDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	TCHAR	sBuffer[300],mesaj[50];
	HDC hdc;
	int gresite = 0,i,j,gasit, nota;
    switch (message)
    {
        case WM_INITDIALOG:
            // Setup the first dialog aspect
            UpdateInfoDlgText( hDlg, PRIMA_INIT);//prima initalizare
			break;
		case WM_PAINT:
			hdc = GetDC(GetDlgItem(hDlg,IDC_IMAGINEA));

			HDC dcMemory;
			dcMemory = CreateCompatibleDC( hdc );
			bmImagine = (HBITMAP)SelectObject(dcMemory, bmImagine);
			StretchBlt(hdc, 2, 2, CIMAGW,CIMAGH, dcMemory, 0, 0,bWidth, bHeight, SRCCOPY );
			bmImagine = (HBITMAP)SelectObject(dcMemory, bmImagine);
			ReleaseDC(hDlg,hdc);
			return FALSE;
			break;
        case WM_COMMAND:
            switch (LOWORD(wParam))
            {
                case IDOK:
					gasit = 1;
					for(i=0;i<iNumarMax&&gasit;i++)
					{
						gasit = 0;
						for(j=0;j<iNumarRaspunsuri;j++)
							if(sIntreb[ordine[i]].select[j]) gasit=1;
					}
					if(!gasit)//am intrebari fara raspuns
						if(IDYES != MessageBox(hDlg,"Exista intrebari fara raspuns,\n confirmati incheierea testului?","Incomplet!",MB_YESNO|MB_ICONERROR)) break;
					//am terminat, verific testul!
					for( i=0; i<iNumarMax;i++)
						for(j=0;j<iNumarRaspunsuri;j++)
							if(sIntreb[ordine[i]].corect[j]
								&&!sIntreb[ordine[i]].select[j])
								gresite++;
					//afisez...
					EndDialog( hDlg, TRUE );
					nota = ((iNumarMax-gresite)*100)/iNumarMax;
					if(gresite >4)
						strcpy(mesaj,"Ai PICAT testul :(\nMai invata!");
					else
						strcpy(mesaj,"Ai REUSIT! :)\nBafta la proba practica");
					wsprintf(sBuffer,"Am corectat!\n=======================\nRezultat:\n   total intrebari:%40d\n   raspunsuri gresite:   %30d\n----------------------\n%s",iNumarMax,gresite,mesaj);
					MessageBox(NULL,sBuffer,"Rezultat",MB_OK|MB_ICONEXCLAMATION);
					break;
                case IDCANCEL:
                    EndDialog( hDlg, TRUE );
                    break;
				case IDC_RADIO1:
				case IDC_RADIO2:
				case IDC_RADIO3:
				case IDC_RADIO4:
					//aduc variabilele la aceasi valoare cu checkbox
					UpdateStruct(hDlg,0,LOWORD(wParam));
					break;
				case IDC_BUTTON1://inapoi
					if(iCurent>0)
						UpdateInfoDlgText( hDlg, iCurent-1);
					break;
				case IDC_BUTTON2://inapoi
					if(iCurent<iNumarMax-1)
						UpdateInfoDlgText( hDlg, iCurent+1);
					break;
                default:
                    return FALSE; // Message not handled 
            }

        default:
            return FALSE; // Message not handled 
    }

    return TRUE; // Message handled 
}


//-----------------------
int InitIntrebari()
{
	//citesc din fisierul FileName
	ifstream fin;
	fin.open(FileName);
		//citesc
		int numarIntreb;//numar in fisier
		char aux[1024],*p;//nume bitmap

		fin>>numarIntreb>>iNumarMax>>iNumarRaspunsuri>>bWidth>>bHeight;
		if(numarIntreb <= 0) {fin.close();return 0;}

		for(int i=0;i<numarIntreb&&!fin.eof();i++)
		{
			fin>>aux;
			for(int j=0;j<strlen(aux);j++) aux[j]=(aux[j]=='%')?' ':aux[j];
			p = strtok(aux,"#");if(!p) break;
			sIntreb[i].img = (HBITMAP)LoadImage(NULL,p,IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE | LR_LOADFROMFILE );
			
			p = strtok(NULL,"#");if(!p) break;
			strcpy(sIntreb[i].text,p);

			for(j=0;j<iNumarRaspunsuri&&j<4;j++)
			{
				p = strtok(NULL,"#");
				if(!p) break;
				strcpy(sIntreb[i].raspuns[j],p);
			}

			p = strtok(NULL,"#");if(!p) break;
			for(j=0;j<strlen(p);j++)
				sIntreb[i].corect[j] = (p[j]=='0'?0:1);
			memset(sIntreb[i].select,0,iNumarRaspunsuri);
		}
		fin.close();
		//am citit tot fisierul, iar acumselectezz iNumarMax
		srand(clock());
		int *siraux = new int[numarIntreb+1],iaux;
		memset(siraux,0,numarIntreb*sizeof(int));
		for(i=0;i<iNumarMax;i++)
		{
			do
				iaux = rand()%numarIntreb;
			while(siraux[iaux]);
			ordine[i] = iaux;
			siraux[iaux] = 1;
		}
		delete[] siraux;
		return TRUE;
}
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	hInst = hInstance;
	abortP = 0;
	while(!abortP)
	{
		abortP = 1;
		if(InitIntrebari())
		DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG1), 
			   GetDesktopWindow(), (DLGPROC)InfoDlgProc );
		else MessageBox(GetDesktopWindow(),"eroare:fisierul nu exista!","eroare",MB_OK|MB_ICONERROR);
		if(IDYES == MessageBox(GetDesktopWindow(),"Repetati testul?","Intrebare",MB_YESNO|MB_ICONQUESTION)) abortP=0;
	}
	return 0;
}
